Package org.apache.sysds.hops

## Class AggUnaryOp

- java.lang.Object
- - org.apache.sysds.hops.Hop
  - - org.apache.sysds.hops.MultiThreadedHop
    - - org.apache.sysds.hops.AggUnaryOp

All Implemented Interfaces:
  `ParseInfo`

    public class AggUnaryOp
    extends MultiThreadedHop

### Field Summary

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

### Constructor Summary

Constructors
`AggUnaryOp​(String l, Types.DataType dt, Types.ValueType vt, Types.AggOp o, Types.Direction idx, Hop inp)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `allowsAllExecTypes()`
`void` `checkArity()` Check whether this Hop has a correct number of inputs.
`Object` `clone()`
`boolean` `compare​(Hop that)`
`Lop` `constructLops()`
`Types.Direction` `getDirection()`
`Types.AggOp` `getOp()`
`String` `getOpString()`
`boolean` `isGPUEnabled()` In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean` `isMultiThreadedOpType()`
`boolean` `isTransposeSafe()` Defines if this operation is transpose-safe, which means that the result of op(input) is equivalent to op(t(input)).
`void` `refreshSizeInformation()` Update the output size information for this hop.
`void` `setDirection​(Types.Direction direction)`
`void` `setOp​(Types.AggOp op)`

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, federatedCostInitialized, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedCost, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getPrivacy, getRepetitions, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasMatrixInputWithDifferentBlocksizes, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetFederatedCost, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedCost, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setPrivacy, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut, updateRepetitionEstimates`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### AggUnaryOp

    public AggUnaryOp​(String l,
                      Types.DataType dt,
                      Types.ValueType vt,
                      Types.AggOp o,
                      Types.Direction idx,
                      Hop inp)

### Method Detail

#### checkArity

    public void checkArity()

Description copied from class: `Hop`
Check whether this Hop has a correct number of inputs. (Some Hops can have a variable number of inputs, such as DataOp, DataGenOp, ParameterizedBuiltinOp, ReorgOp, TernaryOp, QuaternaryOp, MultipleOp, DnnOp, and SpoofFusedOp.) Parameterized Hops (such as DataOp) can check that the number of parameters matches the number of inputs.

Specified by:
  `checkArity` in class `Hop`

#### getOp

    public Types.AggOp getOp()

#### setOp

    public void setOp​(Types.AggOp op)

#### getDirection

    public Types.Direction getDirection()

#### setDirection

    public void setDirection​(Types.Direction direction)

#### isGPUEnabled

    public boolean isGPUEnabled()

Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

#### constructLops

    public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

#### getOpString

    public String getOpString()

Specified by:
  `getOpString` in class `Hop`

#### allowsAllExecTypes

    public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

#### isMultiThreadedOpType

    public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

#### refreshSizeInformation

    public void refreshSizeInformation()

Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

#### isTransposeSafe

    public boolean isTransposeSafe()

Description copied from class: `Hop`
Defines if this operation is transpose-safe, which means that the result of op(input) is equivalent to op(t(input)). Usually, this applies to aggregate operations with fixed output dimension. Finally, this information is very useful in order to safely optimize the plan for sparse vectors, which otherwise would be (currently) always represented dense.

Overrides:
  `isTransposeSafe` in class `Hop`
Returns:
  always returns false

#### clone

    public Object clone()
                 throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

#### compare

    public boolean compare​(Hop that)

Specified by:
  `compare` in class `Hop`